<template>
<div class="page-wrap bg-night">
    <div class="mail-form bg-fake-white">
        <div class="mini-head bg-night">
            <div class="head-case">
                <div class="blockitem">
                    <div class="btn-wrap btn-head txt-gray-mid br20  hover-secondary-light" @click.prevent="back()">
                        <div class="icon-case">
                                <back-icon size="icon-20"/>
                            </div>
                    </div>
                </div>
            </div>
            <div class="head-case">
                <div class="blockitem txt-full-white" style="font-size: 30px; font-weight: 500;">
                    {{isLang.contact.head}}
                </div>
            </div>
        </div>
        <div class="form-part bg-night centered" :class="{'corner-bottom': state.isLoading === false}">
            <transition name="fade">
                <div class="form-wrap" v-if="state.isLoading === false">
                    <template class="mobOnly">
                        <div class="head-section centered centered-txt txt-full-white">
                            <h2 style="margin: 0;"><span class="txt-gray6-dark">{{isLang.contact.to}}</span> {{ dname }}</h2>
                        </div>
                    </template>
                    <div class="ipt-section centered">
                        <div class="wraper-ipt br10">
                            <div class="btn-wrap">
                                <div class="icon-case">
                                    <at-icon size="icon-25 txt-gray6-dark" />
                                </div>
                            </div>
                            <input type="email" class="no-style txt-full-white" ref="iptaddr"
                            :value="state.addr" @input="evt => state.addr = evt?.target.value"
                            placeholder="Email" @keyup.enter="nextInput">
                        </div>
                    </div>
                    <div class="ipt-section centered">
                        <div class="wraper-ipt br10">
                            <div class="btn-wrap">
                                <div class="icon-case">
                                    <info-icon size="icon-25 txt-gray6-dark" />
                                </div>
                            </div>
                            <input type="text" class="no-style txt-full-white" ref="iptobj"
                            :value="state.obj" @input="evt => state.obj = evt?.target.value"
                            :placeholder="isLang.contact.obj" @keyup.enter="nextInput2">
                        </div>
                    </div>
                    <div class="ipt-section centered">
                        <div class="wraper-area centered br10">
                            <textarea class="txt-full-white" v-model="state.content" cols="28" rows="10"
                             :placeholder="isLang.contact.area" ref="iptmsg"></textarea>
                        </div>
                    </div>
                    <div class="centered" style="padding: 30px">
                        <div class="cta-btn centered bg-secondary txt-night hover-secondary-light"
                         @click.prevent="gotoSuccess">
                    {{isLang.contact.btn}}
                    </div>
            </div>
                </div>
            </transition>
        </div>
    </div>
        <div class="hideMob blabla bg-fake-white" :class="{'corner-top': state.isLoading === false}">
            <div style="margin: 0; height: 65px;"></div>
            <transition name="slide-fade">
                <div class="img-wrap centered" v-if="state.isLoading === false">
                    <div style="margin: 0; width: 70%">
                        <div class="text1" style="margin-bottom: 20px;">
                            <p style="margin: 0; width: 100%" class="centered centered-txt txt-prime">
                            {{isLang.contact.to}}
                            </p>
                            <p style="margin: 0; width: 100%" class="centered centered-txt txt-night">
                            {{dname}}
                            </p>
                        </div>
                        <div style="margin: 0; width: 100%" class="centered">
                            <mail-open size="size-svg" :class="{'is-flotte': state.flotte === true}" />
                        </div>
                    </div>
                </div>
            </transition>
        </div>
</div>
</template>

<script setup lang="ts">
import { reactive, ref, onMounted } from 'vue';
import { useRouter } from 'vue-router';
import langStore from '../store/langStore';
import BackIcon from '../components/icons/BackIcon.vue';
import AtIcon from '../components/icons/AtIcon.vue';
import InfoIcon from '../components/icons/InfoIcon.vue';
import MailOpen from '../components/MailOpen.vue';
import popup from '../store/popup';
import { validate } from 'email-validator';

const { isLang } = langStore;
const { setPopup } = popup;

const iptaddr = ref();
const iptobj = ref();
const iptmsg = ref();

const state = reactive({
    content: '',
    addr: '',
    obj: '',
    isLoading: true,
    flotte: false
})

const { back, currentRoute } = useRouter();

const dname = currentRoute.value.params.director;

onMounted(() => {
    setTimeout(() => {
        state.isLoading = false;
        setTimeout(() => {
        iptaddr.value.focus();
        state.flotte = true;
    }, 1000)
    }, 500)
    });

async function noInject(x: string): Promise<boolean | undefined> {
    const reg = /^(?=.*[a-z])(?!.*[{}<>()])\S{3,}$/
        try {
            const result2 = reg.test(x);
            return result2;
        } catch (err) {
            console.warn(err);
        }
}

async function sentenceSafe(x: string): Promise<boolean | undefined> {
        const reg = /^[a-zA-Z0-9\s\.\?]*$/
            try {
                const result2 = reg.test(x);
                return result2;
            } catch (err) {
                console.warn(err);
            }
    }

async function validMail(): Promise<boolean | string> {
    try {
        const det = await noInject(state.addr);
        if (det !== true) {
            throw new Error(isLang.value.popup.warn5);
        }
        if (state.addr.length < 3) {
            throw new Error(isLang.value.popup.warn1);
        }
        if (validate(state.addr) !== true) {
            throw new Error(isLang.value.popup.warn2)
        }
        return true;
    } catch (err: any) {
        return err.message;
    }
}

async function validObj(): Promise<boolean | string> {
    try {
        const det = await sentenceSafe(state.obj);
        if (det !== true) {
            throw new Error(isLang.value.popup.warn5);
        }
        if (state.obj.length < 3) {
            throw new Error(isLang.value.popup.warn1);
        }
        return true;
    } catch (err: any) {
        return err.message;
    }
}

async function nextInput(): Promise<void> {
    try {
        const dg = await validMail();
        if (dg !== true) {
            throw new Error(dg as string)
        }
        iptobj.value.focus();
    } catch(err: any) {
        setPopup(err, 'danger');
    }
}
async function nextInput2(): Promise<void> {
    try {
        const dg = await validObj();
        if (dg !== true) {
            throw new Error(dg as string)
        }
        iptmsg.value.focus();
    } catch(err: any) {
        setPopup(err, 'danger');
    }
}
async function gotoSuccess(): Promise<void> {
    try {
        const deg = await validMail();
        if (deg !== true) {
            throw new Error(deg as string)
        }
        const dsh = await validObj();
        if (dsh !== true) {
            throw new Error(dsh as string)
        }
        if(state.content.length < 3) {
            throw new Error(isLang.value.popup.warn6);
        }
        setPopup(isLang.value.popup.msg2, 'prime');
    } catch(err: any) {
        setPopup(err, 'danger');
    }
}
// le message ser parsé et tous les caractères spéciaux seront échappés
</script>

<style scoped>
img {
  width: 100%;
  height: 100%;
}
.page-wrap {
    margin: 0;
    height: 100vh;
}
.head-case {
    margin: 0;
    height: 65px;
    min-width: 65px;
}
.mail-form {
    margin: 0;
    height: 100%;
    width: 100%;
}
.mini-head {
    margin: 0;
    height: 65px;
    display: flex;
}
.form-part {
    margin: 0;
    height: calc(100% - 65px);
    width: 100%;
}
.form-wrap {
    height: 90%;
    width: 90%;
}
.head-section{
    margin: 0;
    padding: 10px;
    min-height: 65px;
    }
.ipt-section{
    margin: 0;
    padding: 10px;
}
.wraper-ipt {
    width: 90%;
    height: 50px;
    display: flex;
    border-bottom: 2px solid var(--night)
}
.wraper-ipt:focus-within {
    background: var(--night-light);
    transition: background .6s;
}
.wraper-area {
    width: 90%;
    border-bottom: 2px solid var(--night);
}
.wraper-area:focus-within {
    background: var(--night-light);
    transition: background .6s;
}
textarea {
    width: 100%;
    background: none;
    border: none;
    outline: none;
    font-family: 'Roboto', sans-serif;
    font-size: 20px;
    font-weight: 500;
    padding: 10px;
}
.cta-btn {
  padding-top: 8px;
  padding-bottom: 8px;
  padding-left: 20px;
  padding-right: 20px;
  min-height: 15px;
  width: 50%;
  cursor: pointer;
  font-weight: 700;
  border-radius: 20px;
}

@media (min-width: 1024px) {
    .page-wrap {
        display: flex;
    }
    .mail-form {
    margin: 0;
    height: 100%;
    width: 50%;
    }
    .blabla {
    margin: 0;
    height: 100%;
    width: 50%;
    }
    .img-wrap {
    margin: 0;
    height: calc(100% - 65px);
    width: 100%;
    }
    .size-svg {
        width: 65%;
    }
    
    .corner-top {
        border-top-left-radius: 40px;
        transition: border-top-left-radius .8s;
    }
    .corner-bottom {
        border-bottom-right-radius: 40px;
        transition: border-bottom-right-radius .8s;
    }
    .form-wrap {
        height: 90%;
        width: 80%;
    }
    
    .text1 {
    margin: 0;
    /*padding: 10px;*/
    font-weight: 800;
    font-size: 50px;
    }

    .is-flotte {
        animation: flotte 2s linear infinite;
    }

    @keyframes flotte {
        0% {transform: translateY(0);}
        50% {transform: translateY(15px);}
        100% {transform: translateY(0);}
    }
}
</style>
